

# JIN SQL SCHEMA


#
# USER

create table jin_user
(
  id            int(11) not null primary key,
  label         varchar(255) not null default '',
  
  signature     char(16) not null,

  registered    int(1) not null default 0,
  
  referer_id    int(11) not null default 0,

  regtime       datetime null,
  sestime       datetime null,
  reg_ip        varchar(32) not null default '',
  lastlog_ip    varchar(32) not null default '',

  points        int(11) not null default 0,

  email         varchar(255) not null,
  passwd        varchar(255) not null,
  passwd_md5    varchar(32) not null,
  fname         varchar(255) not null default '',
  lname         varchar(255) not null default '',
  name          varchar(255) not null default '',

  address       varchar(255) not null default '',
  city          varchar(255) not null default '',
  state         varchar(255) not null default '',
  zipcode       varchar(255) not null default '',
  country       varchar(255) not null default '',

  shipping_address varchar(255) not null default '',
  shipping_city    varchar(255) not null default '',
  shipping_state   varchar(255) not null default '',
  shipping_zipcode varchar(255) not null default '',
  shipping_country varchar(255) not null default '',

  url           varchar(255) not null default '',
  company       varchar(255) not null default '',
  phone         varchar(255) not null default '',
  checks        varchar(255) not null default '',
  tax_id        varchar(255) not null default '',

  pg_paypal_email           varchar(255) not null default '',
  cb_aff_id                 varchar(150) not null default '',

  no_admin_mail             int(1) not null default 0,
  no_upline_mail            int(1) not null default 0,
  
  adminlink_tstamp          datetime null,
  adminlink_html            varchar(255) not null default '',
  
  admin_notes   text not null default '',
  tracklink_id  int(11) not null default 0,
  
  ext_id        int(11) not null default 0,
  
  paypal_adaptpay_link      varchar(255) not null default '',
  access_by_dt tinyint(1) DEFAULT NULL,
  access_dt_from datetime DEFAULT NULL,
  access_dt_till datetime DEFAULT NULL,

  unique key(email),
  key(reg_ip),
  key(signature)
);

create table jin_merchant_settings
(
  id                        int(11) not null primary key,

  sitename                  varchar(255) not null default '',
  from_name                 varchar(255) not null default '',
  from_email                varchar(255) not null default '',
  tech_email                varchar(255) not null default '',
  turboaffid                varchar(255) not null default '',
  help_url_forum            varchar(255) not null default '',
  help_url_helpdesk         varchar(255) not null default '',

  autoresp_ma2cust_ids      varchar(255) not null default '',

  email_ma2cust             text not null default '',
  
  email_for_errormsg        text not null default '',

  currency                  char(3) not null,

  backpay_use               int(1) not null default 0,
  backpay_pgates            varchar(50) not null default '',
  
  limit_user_reg_ip         int(4) not null default 0,
  aff_prevailing_mode       int(1) not null default 0,
  
  force_https               int(1) not null default 0,
  
  reg_1optin                int(1) not null default 0,
  reg_cfm_url               varchar(255) not null default '',
  first_login_url           varchar(255) not null default '',
  autoassign_memberships    varchar(255) not null default '',
  autoassign_roles          varchar(255) not null default '',
  autoassign_affprogs       varchar(255) not null default '',
  api_post_regcfm           varchar(255) not null default '',
  api_post_changeuser       varchar(255) not null default '',

  welcome_screen_on         int(1) not null default 0,
  welcome_screen            text not null default '',
  
  admin_dashboard_on        int(1) not null default 0,
  
  labelling                 text not null default '',
  no_regbutton              int(1) not null default 0,
  email_log_enabled         int(1) not null default 0,
  
  refsale_autocancel_period    int(3) not null default 0,
  ccupdate_request_intervals   varchar(30) not null default '',
  ccupdate_notify_admins       varchar(50) not null default '',
  
  jvzooipn_secret           varchar(255) not null default ''
);

create table jin_affiliate_settings
(
  id                        int(11) not null primary key,

  autoresp_me2cust_ids      varchar(255) not null default '',
  autoresp_me2refered_ids   varchar(255) not null default '',

  email_me2refered          text not null default ''
);

#
# ROLES

create table jin_role
(
  id             int(11) not null primary key,

  title          varchar(255) not null default '',

# gone in jin-3-17
# autoassign     int(1) not null default 0,
  needapproval   int(1) not null default 0,
  
  enhanced_mode  int(1) not null default 0,

  priv_supervisor                      int(1) not null default 0,

  priv_auth_profile_login tinyint(1) NOT NULL DEFAULT '0',
  priv_auth_profile_merchant           int(1) not null default 0,
  priv_auth_profile_smtpservers           int(1) not null default 0,
  priv_auth_profile_apicenter          int(1) not null default 0,
  priv_auth_profile_security           int(1) not null default 0,
  priv_auth_profile_member             int(1) not null default 0,
  priv_auth_profile_pgates             int(1) not null default 0,
  priv_auth_profile_affpgates          int(1) not null default 0,

  priv_master_store_packages           varchar(50) not null default '',
  priv_master_store_products           varchar(50) not null default '',
  priv_master_store_funnels            varchar(50) not null default '',
  priv_master_store_oneclickords       varchar(50) not null default '',
  priv_master_store_minisites          varchar(50) not null default '',
  priv_master_store_jvproducts         varchar(50) not null default '',
  priv_master_store_specprices         varchar(50) not null default '',
  priv_master_store_shopcarts          varchar(50) not null default '',
  priv_master_store_otos               varchar(50) not null default '',
  priv_master_store_downloads          varchar(50) not null default '',
  priv_master_store_brandpdfs          varchar(50) not null default '',
  priv_master_store_memberships        varchar(50) not null default '',
  priv_master_store_quests             varchar(50) not null default '',
  priv_master_store_extscripts         varchar(50) not null default '',
  priv_master_store_taxes              varchar(50) not null default '',
  priv_master_store_shippings          varchar(50) not null default '',
  
  priv_master_customers_sales          varchar(50) not null default '',
  priv_master_customers_jvmsubs        varchar(50) not null default '',
  priv_master_customers_actsubs        varchar(50) not null default '',
  priv_master_customers_memberships    varchar(50) not null default '',
  priv_master_customers_quests         varchar(50) not null default '',
  priv_master_customers_extscripts     varchar(50) not null default '',
  priv_master_customers_shipdue        varchar(50) not null default '',
  priv_master_customers_tracklinks     varchar(50) not null default '',

  priv_master_affiliates_users         varchar(50) not null default '',
  priv_master_affiliates_affprogs      varchar(50) not null default '',
  priv_master_affiliates_campaigns     varchar(50) not null default '',
  priv_master_affiliates_series        varchar(50) not null default '',
  priv_master_affiliates_commissions   varchar(50) not null default '',
  priv_master_affiliates_paycomms      varchar(50) not null default '',
  priv_master_affiliates_royalties     varchar(50) not null default '',

  priv_master_users_all                varchar(50) not null default '',
  priv_master_users_massmail           varchar(50) not null default '',
  priv_master_users_massuserop         varchar(50) not null default '',
  priv_master_users_roles              varchar(50) not null default '',
  priv_master_users_specusers          varchar(50) not null default '',
  priv_master_users_customfields       varchar(50) not null default '',
  priv_master_users_downlines          varchar(50) not null default '',
  priv_master_users_import             varchar(50) not null default '',
  priv_master_users_invite             varchar(50) not null default '',
  priv_master_users_approve            varchar(50) not null default '',
  priv_master_users_insignia           varchar(50) not null default '',

  priv_master_tools_stats              varchar(50) not null default '',
  priv_master_tools_templates          varchar(50) not null default '',
  priv_master_tools_emails             varchar(50) not null default '',
  priv_master_tools_customtags         varchar(50) not null default '',
  priv_master_tools_forms              varchar(50) not null default '',
  priv_master_tools_bans               varchar(50) not null default '',
  priv_master_tools_coupons            varchar(50) not null default '',
  priv_master_tools_rewards            varchar(50) not null default '',
  priv_master_tools_shorturls          varchar(50) not null default '',
  priv_master_tools_export             varchar(50) not null default '',
  priv_master_tools_pieces             varchar(50) not null default '',
# gone in jin-3-37
#  priv_master_tools_apiuser            varchar(50) not null default '',
#  priv_master_tools_apipost            varchar(50) not null default '',
  priv_master_tools_dbbackup           varchar(50) not null default '',
  priv_master_tools_satelliteinstallations varchar(50) not null default '',
    
  priv_master_plugins_invoicepdfs      varchar(50) not null default '',
  priv_master_plugins_promogen         varchar(50) not null default '',
  priv_master_plugins_sponsorships     varchar(50) not null default '',
  priv_master_plugins_supros           varchar(50) not null default '',
  priv_master_plugins_banners          varchar(50) not null default '',
  priv_master_plugins_linkdirs         varchar(50) not null default '',
  priv_master_plugins_alerts           varchar(50) not null default '',
  priv_master_plugins_testimonials     varchar(50) not null default '',
  priv_master_plugins_followupman      varchar(50) not null default '',
  priv_master_plugins_jvevents         varchar(50) not null default '',
  priv_master_plugins_affinbs          varchar(50) not null default '',
  priv_master_plugins_pages            varchar(50) not null default '',
  priv_master_plugins_geoforce         varchar(50) not null default '',
  priv_master_plugins_blogpub          varchar(50) not null default '',
  priv_master_plugins_bcastnews        varchar(50) not null default '',
  priv_master_plugins_certman          varchar(50) not null default '',
  priv_master_plugins_clouds           varchar(50) not null default '',
  priv_master_plugins_multrec          varchar(50) not null default '',
  priv_master_plugins_reminders        varchar(50) not null default '',
  priv_master_plugins_helptickets      varchar(50) not null default '',
  priv_master_plugins_metaaffs         varchar(50) not null default '',
  priv_master_plugins_contseries       varchar(50) not null default '',
  priv_master_plugins_lessonman        varchar(50) not null default '',
  priv_master_plugins_surveys          varchar(50) not null default '',
  priv_master_plugins_trackurls        varchar(50) not null default '',
  priv_master_plugins_ezinepoints      varchar(50) not null default '',

  priv_member_account_purchases        varchar(50) not null default '',
  priv_member_account_mems             varchar(50) not null default '',
  priv_member_account_jvmsubs          varchar(50) not null default '',
  priv_member_account_ccupdate         varchar(50) not null default '',
  priv_member_account_points           varchar(50) not null default '',
  priv_member_account_helptickets      varchar(50) not null default '',
  priv_member_account_backlink         varchar(50) not null default '',
  priv_member_account_surveys          varchar(50) not null default '',

  priv_member_promote_dashboard        varchar(50) not null default '',
  priv_member_promote_affprogs         varchar(50) not null default '',
  priv_member_promote_links            varchar(50) not null default '',
  priv_member_promote_campaigns        varchar(50) not null default '',
  priv_member_promote_sales            varchar(50) not null default '',
  priv_member_promote_commissions      varchar(50) not null default '',
  priv_member_promote_jvproducts       varchar(50) not null default '',
  priv_member_promote_royalties        varchar(50) not null default '',
  priv_member_promote_payroyalties     varchar(50) not null default '',

  priv_member_downline_view            varchar(50) not null default '',
  priv_member_downline_massmail        varchar(50) not null default '',
  priv_member_downline_commissions     varchar(50) not null default '',
  priv_member_downline_refer           varchar(50) not null default '',

  priv_spec_maildownlinenofooter       int(1) not null default 0,
  priv_spec_yourcommissionseecustomer  int(1) not null default 0,
  priv_spec_yourcommissionseezero      int(1) not null default 0,
  priv_spec_autoresowncust             int(1) not null default 0,
  priv_spec_autoresrefcust             int(1) not null default 0,

  limit_massmailnumber                 varchar(50) not null default '',
  limit_massmailperiod                 varchar(50) not null default '',
  limit_memberships                    varchar(50) not null default '',
  limit_labels                         varchar(255) not null default ''
);

create table jin_user_role
(
  id            int(11) not null primary key,

  role_id       int(11) not null,
  role_title    varchar(255) not null,

  user_id       int(11) not null,

  sale_id       int(11) not null default 0,

  expires       date null,
  expired       int(1) not null default 0,

  notapproved   int(1) not null default 0,

  key(user_id),
  key(role_id),
  key(sale_id)
);

# obsolete; used for Pages only now

create table jin_template
(
  id              int(11) not null primary key,

  group_id        int(11) not null,
  group_type      varchar(30) not null default '',
  group_title     varchar(255) not null default '',
  group_active    int(1) not null default 0,
  group_skin      varchar(50) not null default '',

  tmpl_type       varchar(30) not null default '',
  scope           varchar(30) not null default '',

  html_head       text not null default '',
  body_attr       varchar(255) not null default '',
  template        longtext not null default '',

  precedence      int(1) not null default 0,
  compiled        longtext not null default '',

  key(scope,group_type),
  key(group_id),
  key(group_active)
);

create table jin_theme
(
  # type/code: "packord/order_step2"
  tmpl_code       varchar(50) not null default '',
  theme           varchar(20) not null default '',

  html_head       text not null default '',
  body_attr       varchar(255) not null default '',
  template        longtext not null default '',
  
  use_wysiwyg     int(1) not null default 0,

  orig_theme      varchar(150) not null default '',

  custom_s1       varchar(30) not null default '',
  custom_v1       varchar(255) not null default '',
  custom_v2       varchar(255) not null default '',

  unique key(tmpl_code,theme),
  key(theme)
);

create table jin_theme_compiled
(
  tmpl_code       varchar(50) not null default '',
  theme           varchar(20) not null default '',

  precedence      int(1) not null default 0,

  html_head_comp  text not null default '',
  body_attr       varchar(255) not null default '',
  template_comp   longtext not null default '',
  custom_packed   text not null default '',

  real_theme      varchar(50) not null default '',

  unique key(tmpl_code,theme),
  key(theme)
);

create table jin_theme_meta
(
  tmpl_type       varchar(15) not null default '',
  theme           varchar(20) not null default '',

  title           varchar(255) not null default '',
  
  unique key(tmpl_type,theme)
);

#
# PRODUCTS

create table jin_product
(
  id                        int(11) not null primary key,
  
  label                     varchar(255) not null default '',
  `label_add` varchar(255) NOT NULL,
  `label_remove` varchar(255) NOT NULL,

  type                      int(11) not null default 0,
  is_deleted                int(1) not null default 0,

  jvent_user_id             int(11) not null default 0,
  jvent_status              varchar(50) not null default '',
  jvent_commission          varchar(50) not null default '',

  title                     varchar(255) not null default '',
  descr                     text not null default '',
  price                     decimal(8,2) not null default '0',
  cost                      decimal(8,2) not null default '0',

  payplan_id                int(11) not null default 0,

  autochecked               int(1) not null default 0,
  date_availtill            date null,
  time_availtill            time null,

  period_validity           int(11) not null default 0,
  limit_sales_max           varchar(50) not null default '',
  limit_sales_done          varchar(50) not null default '',

  no_renew                  int(1) not null default 0,
  no_cust_salelist          int(1) not null default 0,
  no_thank_you_email        int(1) not null default 0,
  non_taxable               int(1) not null default 0,

  specusers                 int(11) not null default 0,
  specusers_excuse          text not null default '',
  specprice                 text not null default '',
  specprices_plan           int(11) not null default 0,
  multprod_on               int(1) not null default 0,
  discplan                  varchar(255) not null default '',
# master_prods              varchar(50) not null default '',
  master_memberships        varchar(100) not null default '',
  embed_prods               varchar(100) not null default '',
  embed_prods_recur         varchar(100) not null default '',
  upgrade_prod              int(11) not null default 0,

  send_cust_login_data      int(1) not null default 0,

  api_post_notifysale       varchar(255) not null default '',  

  owner_name                varchar(255) not null default '',
  owner_email               varchar(255) not null default '',

  aff_prevailing_mode             int(1) not null default 0,
  commission_aff                  varchar(255) not null default '',
  aff_instcomm_on                 int(1) not null default 0,
  aff_instcomm_percent            int(3) not null default 0,
  aff_instcomm_order              int(1) not null default 0,
  aff_instcomm_tstamp             datetime null,
  commission_charity              varchar(255) not null default '',
  period_guarantee                int(11) not null default 0,
  period_guarantee_no4recur       int(1) not null default 0,
  comm_recur_stop                 int(3) not null default 0,
  
  quickresell_enabled             int(1) not null default 0,
  quickresell_commission_royalty  varchar(50) not null default '',
  quickresell_price_min           varchar(10) not null default '',
  quickresell_price_max           varchar(10) not null default '',
  quickresell_instructions        text not null default '',
  
  shopcart_enabled                int(1) not null default 0,
  shopcart_image_url              varchar(255) not null default '',
  
  rating_total                    int(11) not null default 0,
  rating_votes                    int(11) not null default 0,
  rating_last_ip                  varchar(50) not null default '',
  
  points_obtain_cust              varchar(50) not null default '',
  points_obtain_cust_recur        int(1) not null default 0,
  points_obtain_aff               varchar(50) not null default '',
  points_obtain_aff_recur         int(1) not null default 0,
  points_price                    varchar(50) not null default '',
  pointscomm_aff                  int(1) not null default 0,
  pointscomm_jvpartner            int(1) not null default 0,
  
  shipping_group_id               int(11) not null default 0,
  
  dlv_instructions          text not null default '',
  dlv_otos                  varchar(255) not null default '',
  dlv_downloads             varchar(255) not null default '',
  dlv_downloads_expire      varchar(50) not null default '',
  dlv_brandpdfs             varchar(255) not null default '',
  dlv_memberships           varchar(255) not null default '',
  dlv_roles                 varchar(255) not null default '',
  dlv_affprogs              varchar(255) not null default '',
  dlv_quests                varchar(255) not null default '',
  dlv_extscripts            varchar(255) not null default '',
  dlv_coupons               varchar(255) not null default '',
  dlv_points                varchar(255) not null default '',
  dlv_lessonseries          varchar(255) not null default '',
  dlv_insignia              varchar(255) not null default '',

  pgates                    varchar(255) not null default '',

  backpay_override          int(1) not null default 0,
  backpay_pgates            varchar(50) not null default '',

# gone in jin-3-50
#  pg_recur                  varchar(3) not null default '',
#  pg_use_ext_recur          varchar(255) not null default '',
#  pg_use_int_recur          varchar(255) not null default '',
# gone in jin-3-50
#  pg_recur_period_l         varchar(10) not null default '',
#  pg_recur_period_u         char(1) not null default '',
#  pg_recur_numinst          varchar(10) not null default '',
#  pg_recur_trial_l          varchar(10) not null default '',
#  pg_recur_trial_u          char(1) not null default '',
#  pg_recur_trial_amount     varchar(15) not null default '',
#  pg_recur_shipping         int(1) not null default 0,

  pg_2checkout_pid          varchar(50) not null default '',
  pg_clickbank_linknumber   varchar(50) not null default '',

  key(type,is_deleted),
  key(payplan_id),
  fulltext(title,descr)
) ENGINE=MyISAM;

create table jin_oto
(
  id                      int(11) not null primary key,

  title                   varchar(255) not null default '',
  descr                   longtext not null default '',

  buttons_style           varchar(30) not null default '',
  yesbtn_title            varchar(255) not null default '',
  yesbtn_attr             varchar(255) not null default '',
  nobtn_title             varchar(255) not null default '',
  nobtn_attr              varchar(255) not null default '',

  dest_prod_id            int(11) not null default 0,
  dest_url                varchar(255) not null default ''
);

create table jin_package
(
  id                      int(11) not null primary key,
  label                   varchar(255) not null default '',

  type                    int(11) not null default 0,

  title                   varchar(255) not null default '',
  homepage                varchar(255) not null default '',
  locked                  int(1) not null default 0,
  locked_ext              varchar(255) not null default '',
  squeeze_autoresp_ids    varchar(255) not null default '',
  sale_autoresp_ids       varchar(255) not null default '',
  
  email_welcome           text not null default '',

  aff_prevailing_mode     int(1) not null default 0,
  affprogs                varchar(255) not null default '',
  quickresell_affprogs    varchar(255) not null default '',
  campaigns               varchar(255) not null default '',
  no_aff_area             int(1) not null default 0,
  commission_perclick     varchar(50) not null default '',

#gone in jin-3-38
#  tmpl_group_id           int(11) not null default 0,
#  minisite_tmpl_group_id  int(11) not null default 0,
  promo_window_width      int(11) not null default 0,
  promo_window_height     int(11) not null default 0,
  
  aff_customtags          varchar(255) not null default '',

  signature               char(2) not null default '',

  aweber_yes              int(1) not null default 0,
  aweber_settings         text not null default '',

  abandone_yes            int(1) not null default 0,
  abandone_waithours      varchar(5) not null default '',
  abandone_email          text not null default '',
  abandone_fum_id         int(11) not null default 0,
  
  pgates                  varchar(255) not null default '',

  backpay_override        int(1) not null default 0,
  backpay_pgates          varchar(50) not null default '',

  currency                char(3) not null,
  currency_rate           decimal(10,6) not null default 0,

  hide_prodlist           int(1) not null default 0,
  bypass                  int(1) not null default 0,
  combo_ty                int(1) not null default 0,
  
  html_head               text not null default '',
  html_foot               text not null default '',
# gone in jin-3-50
# pay_now_text            varchar(255) not null default '',
  
  shipping                int(1) not null default 0,
  
  geoforce_enabled        int(1) not null default 0,
  geoforce_ids            varchar(255) not null default '',
  geoforce_limited_sales  int(1) not null default 0,
  
  invoicepdfs             varchar(255) not null default '',
  
  use_terms               int(1) not null default 0,
  
#  notifysale_yes          int(1) not null default 0,
#  notifysale_settings     text not null default '',

  autoassign_memberships   varchar(255) not null default '',

  api_post_notifysale     varchar(255) not null default '',  
  api_post_regcfm         varchar(255) not null default '',  
  
  reflink_disabled        int(1) not null default 0,
  
  key(type)
);

create table jin_package_product
(
  prod_id       int(11) not null,
  pack_id       int(11) not null,
  cat_id        int(11) not null,
  
  upsell        int(1) not null default 0,
  checked       int(1) not null default 0,
  tstamp        timestamp,
  
  key(prod_id,pack_id,cat_id),
  key(pack_id,cat_id)
);

create table jin_package_hit
(
  tstamp              timestamp,

  pack_id             int(11) not null default 0,
  camp_id             varchar(50) not null default '',
  aff_user_id         int(11) not null default 0,

  coo                 char(16) not null,
  referer             varchar(255) not null default '',
  ip                  varchar(50) not null default '',
  
  key(pack_id,camp_id,coo),
  key(camp_id,aff_user_id),
  key(aff_user_id)
);

create table jin_package_hit_ipcache
(
  tstamp              timestamp,
  pack_id             int(11) not null default 0,
  ip                  varchar(50) not null default '',
  key(pack_id,ip)
);

#
# AFFILIATE PROGRAM

create table jin_affprog
(
  id                  int(11) not null primary key,

  title               varchar(255) not null,
  commission_special  varchar(255) not null default '',

# gone in jin-3-17
# autoassign          int(1) not null default 0,
  needapproval        int(1) not null default 0,

  autoresp_ids        varchar(255) not null default '',

  email_welcome       text not null default '',

  comm100             int(1) not null default 0,
  adaptcomm           int(1) not null default 0,

  comm_recur_stop           int(3) not null default 0,

  period_guarantee          int(11) not null default 0,
  period_guarantee_no4recur int(1) not null default 0,

  aff_instcomm_on           int(1) not null default 0,
  aff_instcomm_percent      int(3) not null default 0,
  aff_instcomm_order        int(1) not null default 0,
  aff_instcomm_tstamp       datetime null
);

create table jin_user_affprog
(
  id            int(11) not null primary key,
  
  ctime         datetime null,

  affprog_id    int(11) not null,
  affprog_title varchar(255) not null,

  user_id       int(11) not null,

  sale_id       int(11) not null default 0,

  expires       date null,
  expired       int(1) not null default 0,

  notapproved   int(1) not null default 0,
  comment       varchar(255) not null default '',

  key(user_id),
  key(affprog_id)
);


#
# AUTORESPONDERS and other mailings

create table jin_autoresponder
(
  id            int(11) not null primary key,
  user_id       int(11) not null,

  type          varchar(20) not null default '',

  title         varchar(255) not null default '',
  settings      varchar(255) not null default '',

#  gone in jin-3-32
#  email         varchar(255) not null,
#  subject       varchar(255) not null default '',

  key(user_id)
);

#
# ORDERS, SALES

create table jin_order
(
  id                  int(11) not null primary key,

  ctime               datetime null,
  signature           char(8) not null default '',

# gone in jin-3-50
# sequence            text not null default '',
  complete            int(1) not null default 0,
  
  is_bulk             int(1) not null default 0,

  aweber_done         int(1) not null default 0,

  pack_id             int(11) not null default 0,
  pack_title          varchar(255) not null default '',

  aff_user_id         int(11) not null default 0,
  aff_camp_id         varchar(50) not null default '',

  aff_init_user_id    int(11) not null default 0,
  aff_curr_user_id    int(11) not null default 0,

  user_id             int(11) not null default 0,

  user_email          varchar(255) not null,
  user_fname          varchar(255) not null,
  user_lname          varchar(255) not null,
  user_name           varchar(255) not null,

  user_address        varchar(255) not null default '',
  user_city           varchar(255) not null default '',
  user_state          varchar(255) not null default '',
  user_zipcode        varchar(255) not null default '',
  user_country        varchar(255) not null default '',

  shipping_address    varchar(255) not null default '',
  shipping_city       varchar(255) not null default '',
  shipping_state      varchar(255) not null default '',
  shipping_zipcode    varchar(255) not null default '',
  shipping_country    varchar(255) not null default '',

  user_phone          varchar(255) not null default '',
  user_company        varchar(255) not null default '',

  key(user_id),
  key(aff_user_id)
);

create table jin_sale
(
  id                  int(11) not null primary key,

  tstamp              datetime null,
  tstamp_date         date null,
  ctime               datetime null,
  signature           char(8) not null default '',

  descr               varchar(255) not null default '',
  amount              varchar(50) not null,
  amount_prod         varchar(50) not null default '',
  amount_discount     varchar(50) not null default '',
  amount_tax_pc       varchar(50) not null default '',
  amount_tax_embed    int(1) not null default 0,
  amount_tax          varchar(50) not null default '',
  amount_shipping     varchar(50) not null default '',
  amount_comms        varchar(50) not null default '',
  has_comms           int(1) not null default 0,

  currency            char(3) not null,
  currency_rate       decimal(10,6) not null default 0,

  prod_id             int(11) not null default 0,
  prod_title          varchar(150) not null default '',
  pack_id             int(11) not null default 0,
  pack_title          varchar(150) not null default '',
  funnel_step_id      int(11) not null default 0,
  funnel_step_title   varchar(150) not null default '',
  funnel_splitpage_id int(11) not null default 0,

  numprod             int(11) not null default 0,

  paid                int(1) not null default 0,
  txn_pgate_type      varchar(30) not null default '',
  txn_pgate_id        int(11) not null default 0,
  txn_code            varchar(32) not null default '',
  txn_waiting         int(1) not null default 0,
  txn_return_url      varchar(255) not null default '',
  
  ccs_id              int(11) not null default 0,

  order_id            int(11) not null default 0,
  user_id             int(11) not null default 0,
  aff_user_id         int(11) not null default 0,
  aff_camp_id         varchar(50) not null default '',
  metaaff_id          int(11) not null default 0,
  tracklink_id        int(11) not null default 0,
  container_sale_id   int(11) not null default 0,
  old_sale_id         int(11) not null default 0,

  refund_deadline     date null,
  refunded            int(1) not null default 0,

  remote_ip           varchar(32) not null default '',

  is_subscr           int(1) not null default 0,
  subscr_id           varchar(50) not null default '',
  subscr_not_initial  int(1) not null default 0,
  subscr_inst_number  int(11) not null default 0,
# gone in jin-3-17
# subscr_descr_more   varchar(50) not null default '',
  subscr_amount       varchar(50) not null default '',
  subscr_amount_prod  varchar(50) not null default '',

  no_renew            int(1) not null default 0,
  no_cust_salelist    int(1) not null default 0,

  oto_shown           int(11) not null default 0,
  
  is_quickresell      int(1) not null default 0,
  is_instcomm         int(1) not null default 0,

  download_ctime      datetime null,

  coupon_mode         int(1) not null default 0,
  coupon_code         char(16) not null default 0,
  coupon_discount     varchar(50) not null default '',

  points_cashed       varchar(50) not null default '',
  points_earned       varchar(50) not null default '',

  shipping_id         int(11) not null default 0,
  shipping_subid      varchar(255) not null default '',
  shipping_recur      int(1) not null default 0,

  specprice_descr     varchar(100) not null default '',

  admin_notes         text not null default '',

  key(subscr_id),
  key(order_id),
  key(user_id),
  key(aff_user_id),
  key(txn_code),
  key(aff_camp_id,paid),
  key(tracklink_id,paid),
  key(prod_id),
  key(pack_id),
  key(funnel_step_id),
  key(container_sale_id),
  key(paid),
  key(tstamp_date,paid),
  key(ccs_id)
);

create table jin_syslog
(
  ctime         datetime null,
  seq           int(11) not null,
  name          varchar(50) not null default '',
  message       varchar(255) not null default '',
  type          char(1) not null default '',

  key(name)
);

create table jin_paylog
(
  ctime         datetime null,

  type          varchar(50) not null default '',
  order_id      int(11) not null default 0,
  sale_id       int(11) not null default 0,

  pgate_id      int(11) not null default 0,
  pgate_title   varchar(50) not null default '',

  data          text not null default '',

  key(order_id),
  key(sale_id)
);

create table jin_download
(
  id                  int(11) not null primary key,
  
  signature           char(8) not null default '',
  
  title               varchar(255) not null default '',

  url                 varchar(255) not null default '',
  username            varchar(255) not null default '',
  password            varchar(255) not null default '',

  comment             varchar(255) not null
);

#
# INVITATIONS

create table jin_invitation
(
  id                  int(11) not null primary key,

  signature           char(8) not null default '',

  title               varchar(255) not null default '',

  grant_roles         varchar(255) not null default '',
  grant_affprogs      varchar(255) not null default '',

  promo_affprogs      varchar(255) not null default '',
  commission_refer    varchar(255) not null default '',
  
  final_html          text not null default ''
);

#
# COMMISSIONS

create table jin_commission
(
  id                  int(11) not null primary key,

  ctime               datetime null,

  type                varchar(50) not null,
  descr               varchar(255) not null default '',
  amount              varchar(50) not null,
  tier                int(1) not null default 0,

  pay_deadline        date null,
  paid                int(1) not null default 0,
  paid_tstamp         datetime null,

  cancel_deadline     date null,
  cancelled           int(1) not null default 0,

  sale_id             int(11) not null default 0,

  payer_user_id       int(11) not null default 0,

  ben_user_id         int(11) not null default 0,
  ben_user_name       varchar(255) not null default '',

  key(sale_id),
  key(ben_user_id)
);

#
# INTERNAL SUBSCRIPTIONS

create table jin_jvmsub
(
  id                  int(11) not null primary key,

  title               varchar(255) not null default '',

  subscr_id           varchar(50) not null default '',
  user_id             int(11) not null default 0,
  init_sale_id        integer not null,

  startdate           date null,
  active              int(1) not null,
  cancelled           int(1) not null default 0,
  canceldate          date null,
  cancelreason        varchar(255) not null default '',

  period_l            varchar(20) not null default '',
  period_u            varchar(20) not null default '',
  numinst             varchar(20) not null default '',

  trial_l             varchar(20) not null default '',
  trial_u             char(1) not null default '',
  trial_amount        varchar(20) not null default '',

  period_amount       varchar(20) not null default '',

  refsale_next_ref_id      varchar(32) not null default '',
  refsale_failure_tstamp   datetime null,
  refsale_failure_reason   varchar(255) not null default '',

  key(init_sale_id),
  key(active),
  key(subscr_id)
);

create table jin_campaign
(
  id                int(11) not null primary key,

  aff_id            int(11) not null,
  title             varchar(255) not null default '',

  affprogs          varchar(255) not null default '',

  unify_pack_hits   int(1) not null default 0,
  unify_order_sales int(1) not null default 0,
  count_only_packs  varchar(255) not null default '',
  count_only_prods  varchar(255) not null default '',

  key(aff_id)
);

#
# SPONSORSHIPS

create table jin_sponsor
(
  id                  int(11) not null primary key,
  
  sort                int(11) not null default 0,
  title               varchar(255) not null default '',
  url                 varchar(255) not null default '',
  expire              date null
);

create table jin_sponsor_cfg
(
  id                  int(11) not null primary key,
  orderurl            varchar(255) not null default ''
);

#
# COUPONS

create table jin_coupon
(
  id                      int(11) not null primary key,
  hidden                  int(1) not null default 0,
  parent_coupon_id        int(11) not null,

  active                  int(1) not null default 0,
  exhausted               int(1) not null default 0,

  otc_all                 int(1) not null default 0,
  otc_selected            varchar(255) not null default '',
# gone in jin-3-40
#  otc_existing            int(1) not null default 0,
  otc_existing_since      date null,
  otc_existing_pack       varchar(255) not null default '',
  otc_existing_prod       varchar(255) not null default '',
  otc_memberships         varchar(255) not null default '',
  otc_new                 int(1) not null default 0,
  otc_new_pack            varchar(255) not null default '',
  otc_new_prod            varchar(255) not null default '',
  
  ota_all                 int(1) not null default 0,
  ota_selected            varchar(255) not null default '',
  ota_group               varchar(255) not null default '',
  ota_existing            int(1) not null default 0,
  ota_existing_since      date null,
  ota_new                 int(1) not null default 0,

  for_all                 int(1) not null default 0,
  for_pack                varchar(255) not null default '',
  for_prod                varchar(255) not null default '',

  coupon                  varchar(255) not null default 0,
  discount                varchar(50) not null default '',
  limit_amount            int(11) not null default 0,
  mode                    int(1) not null default 0,

  valid_from              date null,
  valid_until             date null,

  number                  integer not null default 0,
  usage_cust              integer not null default 0,
  usage_aff               integer not null default 0,

  email_cust              text not null default '',
  email_aff               text not null default '',
  
  notes                   text not null default '',

  KEY(hidden),
  key(coupon),
  key(parent_coupon_id)
);


create table jin_coupon_use
(
  coupon_id               int(11) not null default 0,
  cust_user_id            int(11) not null default 0,
  aff_user_id             int(11) not null default 0,

  key(coupon_id),
  key(cust_user_id),
  key(aff_user_id)
);

#
# REWARD PROGRAMS

create table jin_reward
(
  id                      int(11) not null primary key,

  active                  int(1) not null default 0,
  type                    varchar(20) not null default '',

  notes                   text not null default '',

  multiply                int(11) not null default 0,

  valid_from              date null,
  valid_until             date null,

  cust_all                 int(1) not null default 0,
  cust_selected            varchar(255) not null default '',
  cust_existing            int(1) not null default 0,
  cust_existing_since      date null,
  cust_existing_pack       varchar(255) not null default '',
  cust_existing_prod       varchar(255) not null default '',
  cust_new                 int(1) not null default 0,
  cust_new_pack            varchar(255) not null default '',
  cust_new_prod            varchar(255) not null default '',
  cust_paid_min            varchar(20) not null default '',
  cust_paid_max            varchar(20) not null default '',

  aff_all                  int(1) not null default 0,
  aff_selected             varchar(255) not null default '',
  aff_group                varchar(255) not null default '',
  aff_registered_after     date null,
  aff_generate_min         varchar(20) not null default '',
  aff_generate_max         varchar(20) not null default ''
);

create table jin_user_point_history
(
  id                       int(11) not null primary key,

  user_id                  int(11) not null,

  otime                    datetime,
  points_before            int(11) not null,
  points_after             int(11) not null,
  comment                  varchar(255) not null default '',

  key(user_id)
);

#
# BANS

create table jin_ban
(
  id         int(11) not null primary key,
  banlist    longtext not null default ''
);

#
# SHORT URLS

create table jin_short_url
(
  id         int(11) not null primary key,

  alias      varchar(255) not null default '',
  url        varchar(255) not null default '',
  
  admin_notes   text not null default '',
  
  ref_obj_type  varchar(15) not null default '',
  ref_obj_id    int(11) not null default 0,
  
  key(ref_obj_type,ref_obj_id)
);

#
# STATISTIC REPORTS

create table jin_stats_report
(
  id            int(11) not null primary key,

  signature     char(16) not null,
  type          varchar(50) not null default '',
  title         varchar(255) not null default '',
  search        varchar(255) not null default '',

  key(signature)
);

#
# MASSMAIL

create table jin_massmail_counter
(
  user_id       int(11) not null,
  tstamp        timestamp,
  key(user_id)
);

create table jin_massmail_job
(
  job_id        char(16) not null,

  cdate         datetime null,
  fdate         datetime null,
  ldate         datetime null,

  user_id       int(11) not null,
  subject       varchar(255) not null default '',
  scheduled     int(1) not null default 0,
  
  emails_num    int(11) not null default 0,
  emails_sent   int(11) not null default 0,
  complete      int(1) not null default 0,

  key(job_id),
  key(scheduled,complete),
  key(user_id,scheduled,complete)
);

create table jin_massmail_jobitem
(
  job_id          char(16) not null,
  seq             int(11) not null default 0,
  
  sent            int(1) not null default 0,
  failed          varchar(100) not null default '',
  
  format          varchar(50) not null default '',
  subject         varchar(255) not null default '',
  message         text not null default '',
  
  user_id         int(11) not null,
  user_signature  char(16) not null,
  user_fname      varchar(50) not null default '',
  user_lname      varchar(50) not null default '',
  user_email      varchar(70) not null default '',
  user_passwd     varchar(255) not null default '',
  
  from_name       varchar(50) not null default '',
  from_email      varchar(70) not null default '',
  
  key(job_id,seq),
  key(job_id,sent,seq)
);

create table jin_massmail_settings
(
  id            int(11) not null primary key,
  portion_size  int(11) not null default 0
);

#
# SHOPCART

create table jin_shopcart_category
(
  id          int(11) not null primary key,

  pack_id     int(11) not null,
  parent_id   int(11) not null,

  title       varchar(255) not null,
  
  seq         int(11) not null,

  path_id     varchar(255) not null default '',
  path_seq    varchar(255) not null default '',
  
  level       int(11) not null,

  key(pack_id,parent_id),
  key(pack_id,path_seq)
);

#
# SPECIAL CUSTOMERS

create table jin_specusers
(
  id                      int(11) not null primary key,
  type                    varchar(50) not null default '',

  title                   varchar(255) not null default '',
  notes                   text not null default '',

  u_all                   int(1) not null default 0,
  u_selected              varchar(255) not null default '',
  u_since                 date null,
  u_cust_new              int(1) not null default 0,
  u_cust_packs            varchar(255) not null default '',
  u_cust_prods            varchar(255) not null default '',
  u_affprogs              varchar(255) not null default '',
  u_roles                 varchar(255) not null default '',
  u_memberships           varchar(255) not null default '',
  u_insignia              varchar(255) not null default '',
  u_surveys               varchar(255) not null default '',
  u_paid_min              varchar(20) not null default '',
  u_paid_max              varchar(20) not null default '',
  u_generated_min         varchar(20) not null default '',
  u_generated_max         varchar(20) not null default '',
  u_count_sales_from      date null,
  u_count_sales_until     date null,
  
  remote_delavo_api_url   varchar(255) not null default ''
);

#
# PROMO GENERATOR

create table jin_promogen_template
(
  id                      int(11) not null primary key,

  title                   varchar(255) not null default '',
  template                text not null default '',
  type                    varchar(255) not null default '',
  file                    varchar(255) not null default '',
  is_default              int(1) not null default 0,
  
  KEY(type)
);

create table jin_promogen
(
  id                      int(11) not null primary key,

  type                    varchar(20) not null default '',
  seq                     int(11) not null,
  template                int(11) not null,

  title                   varchar(255) not null default '',
  instructions            longtext not null default '',
  subject                 varchar(255) not null default '',
  message                 longtext not null default '',
	
  imageUrl                varchar(255) not null default '',
  url                     varchar(255) not null default '',

  description             longtext not null default '',

  keywords                varchar(255) not null default ''
);

#
# TAXES

create table jin_tax
(
  id        int(11) not null primary key,

  percent   decimal(4,2) not null default 0,
  embedded  int(1) not null default 0,
  
  country   varchar(50) not null default '',
  state     varchar(50) not null default ''
);

#
# JVM ALERTS & API & IPN forward


create table jin_alert_cfg
(
  id                  int(11) not null primary key,
  ad                  text not null default ''
);

create table jin_alert_msg
(
  id                  int(11) not null primary key,

  ptime               datetime null,

  specusers           int(11) not null default 0,
  
  title               varchar(255) not null default '',
  message             text not null default ''
);

create table jin_alert_sync
(
  id                  int(11) not null primary key,
  last_sync_time      datetime
);

create table jin_api_user
(
  id                  int(11) not null primary key,

  title               varchar(255) not null default '',
  secret              varchar(255) not null default '',
  secure              int(1) not null default 0,
  specusers           int(11) not null default 0,

  u_all               int(1) not null default 0,
  u_selected          varchar(255) not null default '',
  u_since             date null,
  u_cust_new          int(1) not null default 0,
  u_cust_packs        varchar(255) not null default '',
  u_cust_prods        varchar(255) not null default '',
  u_affprogs          varchar(255) not null default '',
  u_roles             varchar(255) not null default '',
  u_memberships       varchar(255) not null default '',
  u_insignia          varchar(255) not null default '',
  u_surveys           varchar(255) not null default '',
  u_paid_min          varchar(20) not null default '',
  u_paid_max          varchar(20) not null default '',
  u_generated_min     varchar(20) not null default '',
  u_generated_max     varchar(20) not null default '',
  u_count_sales_from  date null,
  u_count_sales_until date null
);

create table jin_ipn_forward
(
  id                  int(11) not null primary key,

  pgtxn_id            int(11) not null default 0,
  url                 varchar(255) not null,
  params              text not null default '',
  trials              int(3) not null default 3
);

#
# FORM EDITOR

create table jin_form_editor
(
  id            int(11) not null primary key,
  
  code          varchar(50) not null,
  obj_id        int(11) not null default 0,
  data          text not null default ''
);

#
# EXT SCRIPTS

create table jin_ext_script
(
  id            int(11) not null primary key,
  
  title         varchar(255) not null,
  url           varchar(255) not null,
  plugin        varchar(50) not null,

  cfgtext       text not null default '',

  email_create  text not null default '',
  email_delete  text not null default ''
);

#
# UPGRADABLE AFFILIATE PROGRAMS

create table jin_affprog_series
(
  id            int(11) not null primary key,
  title         varchar(255) not null
);

create table jin_affprog_series_step
(
  id                    int(11) not null primary key,

  ctime                 datetime null,

  series_id             int(11) not null default 0,
  affprog_id            int(11) not null default 0,

  upgrade_type          varchar(20) not null default '',
  upgrade_amount        varchar(20) not null default '',
  upgrade_period_n      varchar(10) not null default '',
  upgrade_period_u      char(1) not null default 0,

  downgrade_type        varchar(20) not null default '',
  downgrade_amount      varchar(20) not null default '',
  downgrade_period_n    varchar(10) not null default '',
  downgrade_period_u    char(1) not null default 0,

  email_upgrade text    not null default '',
  email_downgrade text  not null default ''
);

create table jin_affprog_series_history
(
  id                       int(11) not null primary key,
  
  user_id                  int(11) not null,

  series_id                int(11) not null,

  otime                    datetime,
  affprog_id_before        int(11) not null,
  affprog_title_before     varchar(255) not null default '',
  affprog_id_after         int(11) not null,
  affprog_title_after      varchar(255) not null default '',

  comment                  varchar(255) not null default '',

  key(user_id)
);

#
# PGATES


create table jin_pgate
(
  id                    int(11) not null primary key,
  
  user_id               int(11) not null,

  type                  varchar(50) not null default '',
  
  title                 varchar(50) not null default '',
  settings              text not null default '',

  external_ipn          int(1) not null default 0,
  
  key(user_id)
);

create table jin_pgtxn
(
  id                    int(11) not null primary key,
  
  txn_code              varchar(255) not null default '',
  processed             int(1) not null default 0,
  successful            int(1) not null default 0,

  pgate_id              int(11) not null default 0,
  pgate_type            varchar(30) not null default '',
  
  order_id              int(11) not null default 0,
  sale_id               int(11) not null default 0,

  key(order_id,sale_id),
  key(txn_code)
);

#
# EMBEDDED EMAIL

create table jin_embedded_email 
(
  id                          int(11) not null primary key,
  signature                   text not null default '',
  footermassmail              text not null default '',
  footerdownline              text not null default ''
);

#
# QUESTIONNAIRES

create table jin_quest
(
  id             int(11) not null primary key,

  title          varchar(255) not null default '',
  instructions   text not null default '',
  blocking       int(1) not null default 0,
  from_customer  int(1) not null default 0,

  notify_emails  varchar(255) not null default '',
  notify_create  text not null default '',
  notify_delete  text not null default '',

# removed in jin-3-16
#  trigger_url    varchar(255) not null default '',
#  trigger_secret varchar(255) not null default '',
#  trigger_method varchar(10) not null default '',
  
  api_post_quest varchar(255) not null default ''
);

create table jin_quest_item
(
  id          int(11) not null primary key,

  quest_id    int(11) not null,

  title       varchar(255) not null default '',
  mandatory   int(1) not null default 0,
  type        varchar(30) not null default '',
  customlist  text not null default '',

# removed in jin-3-16
#  qsfield     varchar(50) not null default '',
  
  seq         int(11) not null default 0,
  
  key(quest_id,seq)
);

create table jin_user_quest
(
  id           int(11) not null primary key,

  sale_id      int(11) not null default 0,
  user_id      int(11) not null default 0,

  quest_id     int(11) not null,

  expires      date null,
  expired      int(1) not null default 0,

  userinput    text not null default '',
  triggerdata  text not null default '',
  
  complete     int(1) not null default 0,

  key(user_id),
  key(sale_id),
  key(quest_id)
);

#
# SHIPPING

create table jin_shipping
(
  id           int(11) not null primary key,

  type         varchar(50) not null default '',
  
  title        varchar(50) not null default '',
  settings     text not null default '',
  
  email_status text not null default '',
  
  group_id int(11) not null default 0,
  
  key(group_id)
);

create table jin_shipping_group
(
  id           int(11) not null primary key,
  title        varchar(50) not null default '',
  prioritized  int(1) not null default 0
);

create table jin_shipping_due
(
  id           int(11) not null primary key,

  sale_id      int(11) not null default 0,
  shipping_id  int(11) not null,

  descr        varchar(255) not null default '',

  fulfilled    int(1) not null default 0,
  
  procid       varchar(50) not null default '',
  status       varchar(255) not null default '',

  key(sale_id),
  key(fulfilled)
);

create table jin_testimonial_page
(
  id           int(11) not null primary key,
  
  tag          varchar(255) not null default '',
  
  add_code     varchar(255) not null default '',
  ipp          int(11) not null default 0,
  photo_width  int(11) not null default 0,
  template     longtext not null default '',
  
  key(tag)
);

create table jin_testimonial
(
  id            int(11) not null primary key,
  
  approved      int(1) not null default 0,
  ctime         datetime null,
  tag           varchar(255) not null default '',
  
  name          varchar(255) not null default '',
  email         varchar(255) not null default '',
  image         varchar(30) not null default '',
  website_title varchar(255) not null default '',
  website_url   varchar(255) not null default '',
  testimonial   text not null default '',
  
  videofile     varchar(30) not null default '',
  player        varchar(30) not null default '',
  youtube_id    varchar(30) not null default '',
  
  url           varchar(255) not null default '',
  
  key(tag,approved)
);

create table jin_priceinc
(
  id            int(11) not null primary key,

  date_start    date null,
  date_end      date null,
  time_start    time null,
  time_end      time null,
  
  price_start   decimal(8,2) not null default '0',
  price_end     decimal(8,2) not null default '0',
  
  incr          varchar(32) not null default '',
  period_l      int(4) not null default 0,
  period_u      varchar(15) not null default '',

  jsflow        int(1) not null default 0,
  
  template      text not null default ''  
);

create table jin_followupman_series
(
  id            int(11) not null primary key,
  
  prods         varchar(255) not null default '',
  title         varchar(255) not null default '',
  
  from_name     varchar(255) not null default '',
  from_email    varchar(255) not null default '',
  
  double_optin  int(1) not null default 0,
  hide_thank    int(1) not null default 0,
  
  del_series    varchar(255) not null default ''
);

create table jin_followupman_series_message
(
  id            int(11) not null primary key,
  series_id     int(11) not null default 0,
  
  delay         int(11) not null default 0,
  
  message       text not null default '',
  subject       varchar(255) not null default '',
  
  seq           int(3) not null,
  
  plain_text    int(1) not null default 0,
  
  recur_yes     int(1) not null default 0,
  recur_num     int(8) not null default 0,
  recur_delay   int(11) not null default 0,
  
  co_mode       int(1) not null default 0,
  co_from_email varchar(255) not null default '',
  co_to_emails  text not null default '',
  co_subject    varchar(255) not null default '',
  co_message    text not null default '',
  co_plain_text int(1) not null default 0,
  
  key(series_id)
);

create table jin_followupman_user_series
(
  id            int(11) not null primary key,
  user_id       int(11) not null default 0,
  
  message_id    int(11) not null default 0,
  series_id     int(11) not null default 0,
  
  stime         datetime null,
  
  confirmed     int(1) not null default 0,
  signature     char(8) not null,
  
  optout        int(1) not null default 0,
  optout_tstamp datetime null,
  
  sale_id       int(11) not null default 0,
  
  key(user_id),
  key(sale_id),
  key(series_id),
  key(confirmed,optout,message_id)
);

create table jin_followupman_template
(
  id                          int(11) not null primary key,

  confirm_subscription        text not null default ''
);

create table jin_followupman_user_recur
(
  user_series_id              int(11) not null default 0,
  message_id                  int(11) not null default 0,
  
  num                         int(8) not null default 0,
  stime                       datetime null,
  
  key(user_series_id),
  key(message_id)
);

create table jin_user_dlv
(
  id        int(11) not null primary key,
  
  ctime     datetime null,

  type      varchar(50) not null default '',
  obj_id    int(11) not null,
  obj_title varchar(255) not null,

  user_id   int(11) not null,

  sale_id   int(11) not null default 0,

  expires   date null,
  expired   int(1) not null default 0,

  key(type,obj_id),
  key(user_id),
  key(sale_id)
);

create table jin_brandpdf
(
  id                  int(11) not null primary key,

  title               varchar(150) not null default '',
  filename            varchar(150) not null default '',
  template            longtext not null default ''
);

create table jin_invoicepdf
(
  id        int(11) not null primary key,

  title     varchar(150) not null default '',
  template  longtext not null default '',
  format    varchar(10) not null default ''
);

create table jin_terms
(
  id         int(11) not null primary key,
  terms      longtext not null default ''
);

create table jin_supro
(
  id                   int(11) not null primary key,

  alias                varchar(255) not null default '',
  url                  varchar(255) not null default '',
  username             varchar(255) not null default '',
  password             varchar(255) not null default '',
  
  limit_ips            int(6) not null default 0,
  limit_ips_user       int(6) not null default 0,
  limit_downloads      int(6) not null default 0,
  limit_downloads_user int(6) not null default 0,
  limit_referer        text not null default '',
  
  expires              date null,
  
  admin_notes          text not null default '',
  denied_template      int(11) not null default 0,
  
  u_all                int(1) not null default 0,
  u_selected           varchar(255) not null default '',
  u_since              date null,
  u_cust_new           int(1) not null default 0,
  u_cust_packs         varchar(255) not null default '',
  u_cust_prods         varchar(255) not null default '',
  u_affprogs           varchar(255) not null default '',
  u_roles              varchar(255) not null default '',
  u_memberships        varchar(255) not null default '',
  u_insignia           varchar(255) not null default '',
  u_surveys            varchar(255) not null default '',
  u_paid_min           varchar(20) not null default '',
  u_paid_max           varchar(20) not null default '',
  u_generated_min      varchar(20) not null default '',
  u_generated_max      varchar(20) not null default '',
  u_count_sales_from   date null,
  u_count_sales_until  date null
);

create table jin_supro_stat
(
  supro_id          int(11) not null default 0,
  tstamp            datetime null,
  ip                varchar(32) not null default '',
  referer           varchar(255) not null default '',
  user_id           int(11) not null default 0,
  user_email        varchar(255) not null default '',
  
  key(supro_id)
);

create table jin_jvevent
(
  id                int(11) not null primary key,
  
  signature         char(8) not null default '',
  
  title             varchar(255) not null default '',
  
  membership_id     int(11) not null default 0,
  rights            varchar(255) not null default '',
  pagesize          int(3) not null default 0,
  period_validity   int(11) not null default 0,
  
  max_video_size    int(6) not null default 0,
  max_image_size    int(6) not null default 0,
  max_download_size int(6) not null default 0,
  
  def_user_image    varchar(255) not null default '',
  user_image_width  int(11) not null default 0,  
  
  template_list     longtext not null default '',
  template_submit   longtext not null default '',
  
  style_id          int(11) not null default 0,
  
  key(signature)
);

create table jin_jvevent_prod
(
  id            int(11) not null primary key,
  
  signature     char(8) not null default '',
  ctime         datetime null,
  
  jvevent_id    int(11) not null default 0,
  approved      int(1) not null default 0,
  sortdate      datetime null,
  
  title         varchar(255) not null default '',
  url           varchar(255) not null default '',
  descr         text not null default '',
  price         varchar(30) not null default '',
  cover_url     varchar(255) not null default '',
  download_url  varchar(255) not null default '',
  rights        varchar(255) not null default '',
  
  partner_name           varchar(255) not null default '',
  partner_email          varchar(255) not null default '',
  partner_website_title  varchar(255) not null default '',
  partner_website_url    varchar(255) not null default '',
  
  testim_text            text not null default '',
  testim_player          varchar(30) not null default '',
  testim_youtube         varchar(30) not null default '',
  testim_video_url       varchar(255) not null default '',

  key(jvevent_id,approved)
);

create table jin_jvevent_rights
(
  id     int(11) not null primary key,
  title  varchar(255) not null default ''
);

create table jin_style
(
  id          int(11) not null primary key,
  
  title       varchar(255) not null default '',
  
  width       varchar(30) not null default '',
  bgcolor     varchar(30) not null default '',
  font_color  varchar(30) not null default '',
  font_style  varchar(30) not null default '',
  font_size   varchar(30) not null default '',
  
  css_class   varchar(50) not null default '',
  css_style   varchar(255) not null default ''
);

create table jin_customtag
(
  id          int(11) not null primary key,
  label       varchar(255) not null default '',
  
  tagname     varchar(50) not null default '',
  comment     varchar(255) not null default '',
  def_value   text not null default '',
  
  unique key(tagname)
);

create table jin_customtag_aff
(
  aff_user_id   int(11) not null default 0,
  pack_id       int(11) not null default 0,
  tag_id        int(11) not null default 0,
    
  tag_value     text not null default '',
  
  unique key(pack_id,tag_id,aff_user_id)
);

create table jin_linkdir
(
  id                    int(11) not null primary key,
  
  title                 varchar(255) not null default '',
  categories            text not null default '',
  
  first_page_size       int(11) not null default 0,
  
  style_id              int(11) not null default 0,
  
  allow_visitors_links  int(1) not null default 0,
  
  sponsor_membership    int(11) not null default 0,
  sponsor_numlinks      int(11) not null default 0,
  sponsor_orderlink     varchar(255) not null default ''
);

create table jin_linkdir_link
(
  id          int(11) not null primary key,
  
  signature   char(16) not null,
  
  linkdir_id  int(11) not null default 0,
  category    varchar(255) not null default '',

  pdate       datetime null,
  onhold      int(1) not null default 0,

  title       varchar(255) not null default '',
  url         varchar(255) not null default '',
  descr       text not null default '',
  email       varchar(255) not null,
  
  key(linkdir_id,onhold),
  key(linkdir_id,email)
);

create table jin_banner
(
  id          int(11) not null primary key,
  
  title       varchar(255) not null default ''
);

create table jin_banner_item
(
  id          int(11) not null primary key,
  banner_id   int(11) not null default 0,
  
  title       varchar(255) not null default '',
  url         varchar(255) not null default '',
  weight      varchar(10) not null default '',
  image       varchar(255) not null default '',
   
  html_text   text not null default '',
  
  key(banner_id)
);

create table jin_banner_stat
(
  banner_id   int(11) not null default 0,
  item_id     int(11) not null default 0,
  referer     varchar(255) not null default '',
  views       int(11) not null default 0,
  clicks      int(11) not null default 0,

  key(banner_id,item_id,referer)
);

create table jin_affinb
(
  id        int(11) not null primary key,
  
  aff_id    int(11) not null default 0,
  pack_id   int(11) not null default 0,
  
  active    int(1) not null default 0,
  
  descr           longtext not null default '',
  html_delivery   longtext not null default '',
  email_delivery  text not null default '',
  
  key(aff_id,pack_id)
);

create table jin_affinb_cfg
(
  id           int(11) not null primary key,
  
  affprogs     varchar(255) not null default ''
);

create table jin_affinb_template
(
  id           int(11) not null primary key,
  
  template     longtext not null default ''
);


create table jin_quickresell
(
  id          int(11) not null primary key,
  
  aff_id      int(11) not null default 0,
  
  prod_id     int(11) not null default 0,
  price       decimal(8,2) not null default '0',
  pgates      varchar(255) not null default '',
  
  key(aff_id,prod_id),
  key(prod_id)
);

create table jin_membership
(
  id                  int(11) not null primary key,
  
  type                varchar(50) not null,

# jincms.ext_script
  custom_int          int(11) not null,
# jin_lmem.path, jin_rmem.ftp_serv, jin_cms.path
  custom_v1           varchar(255) not null,
# jin_rmem.ftp_user
  custom_v2           varchar(255) not null,
# jin_rmem.ftp_pass
  custom_v3           varchar(255) not null,
# jin_rmem.ftp_dir
  custom_v4           varchar(255) not null,

  url                 varchar(255) not null,
  
  comment             varchar(255) not null,
  
  insecure            int(1) not null default 0,
  use_altauth         int(1) not null default 0,
  
  email_access        text not null default '',
  email_renew         text not null default '',
  email_renew_period  int(11) not null default 0,
  email_delete        text not null default ''
);

create table jin_page
(
  id                int(11) not null primary key,
  label             varchar(255) not null default '',

  group_id          int(11) not null default 0,
  group_title       varchar(255) not null default '',
  group_tmpl_id     int(11) not null default 0,
  group_protection  varchar(10) not null default '',
  group_mems        varchar(255) not null default '',
  group_menu        text not null default '',

  url               varchar(255) not null default '',

  title             varchar(255) not null default '',
  tmpl_id           int(11) not null default 0,
  protection        varchar(10) not null default '',
  type              varchar(20) not null default '',

  content           longtext not null default '',
  template          longtext not null default '',

  key(group_id),
  key(url)
);

create table jin_geoforce
(
  id               int(11) not null primary key,

  title            varchar(255) not null default '',

  country          varchar(10) not null default '',
  state            varchar(10) not null default '',

  user_id          int(11) not null default 0,
  user_order_link  varchar(255) not null default '',

  key(user_id),
  key(country,state)
);

create table jin_blogpub
(
  id               int(11) not null primary key,
  
  blog_type        varchar(30) not null default '',

  title            varchar(255) not null default '',
  url              varchar(255) not null default '',
  username         varchar(255) not null,
  password         varchar(255) not null,
  format           int(1) not null default 0,

#gone in jin-3-31
#  custom           int(1) not null default 0,
  
  login_url        varchar(255) not null default '',
  login_params     text not null default '',

  pub_url          varchar(255) not null default '',
  pub_params       text not null default ''
);

create table jin_bcastnews
(
  id                  int(11) not null primary key,
  
  display_on_ws       int(1) not null default 0,
  
  display_mode        int(3) not null default 0,
  display_mode_value  int(3) not null default 0,
  
  secret_word         varchar(50) not null default '',
  
  template            text not null default '',
  template_one_msg    text not null default ''
);

create table jin_bcastnews_message
(
  id             int(11) not null primary key,
  
  pdate          datetime null,
  
  message_brief  text not null default '',
  message_full   text not null default '',
  
  author         varchar(50) not null default '',
  
  key(pdate)
);

create table jin_bcastnews_feeder
(
  id             int(11) not null primary key,
  
  title          varchar(255) not null default '',
  
  url            varchar(255) not null default '',
  secret_word    varchar(50) not null default '',
  
  user_id        int(11) not null default 0,
  membership_id  int(11) not null default 0
);

create table jin_shopcart_review
(
  id            int(11) not null primary key,
  
  prod_id       int(11) not null default 0,
  
  approved      int(1) not null default 0,
  
  pdate         datetime null,
  message       text not null default '',
  author_name   varchar(50) not null default '',
  author_email  varchar(255) not null default '',
  
  key(prod_id,approved)
);

create table jin_shopcart_settings
(
  id                 int(11) not null primary key,
  
  pack_id            int(11) not null default 0,
  
  review_moderation  int(1) not null default 0,
  review_pagesize    int(11) not null default 0,
  
  catalog_img_width  int(11) not null default 0,
  catalog_pagesize   int(11) not null default 0,
  prodinfo_img_width int(11) not null default 0,
  gallery_img_height int(11) not null default 0,
  
  key(pack_id)
);

create table jin_certman
(
  id             int(11) not null primary key,
  
  membership_id  int(11) not null default 0,
  
  date_color     varchar(11) not null default '',
  date_font      int(8) not null default 0,
  date_format    varchar(30) not null default '',
  date_x         int(8) not null default 0,
  date_y         int(8) not null default 0,
  
  id_color       varchar(11) not null default '',
  id_font        int(8) not null default 0,
  id_x           int(8) not null default 0,
  id_y           int(8) not null default 0,
  
  name_color     varchar(11) not null default '',
  name_font      int(8) not null default 0,
  name_x         int(8) not null default 0,
  name_y         int(8) not null default 0,
  
  copyright      varchar(255) not null default '',
  
  url            varchar(255) not null default '',  
  template       longtext not null default '',
  width          int(8) not null default 0,
  height         int(8) not null default 0,
  
  nc_url         varchar(255) not null default '',  
  nc_template    longtext not null default '',
  nc_width       int(8) not null default 0,
  nc_height      int(8) not null default 0
);

create table jin_specprices
(
  id             int(11) not null primary key,
  
  title          varchar(255) not null default '',
  settings       text not null default ''
);

create table jin_cloud_page
(
  id                  int(11) not null primary key,
  
  title               varchar(255) not null default '',
  
  pre_moderation      int(1) not null default 0,
  pagesize            int(3) not null default 0,
  remain_on_top_days  int(3) not null default 0,
  status_list         varchar(255) not null default '',
  
  template            longtext not null default '',
  css_style           text not null default ''
);

create table jin_cloud
(
  id                int(11) not null primary key,
  signature         char(8) not null default '',
  
  cloud_page_id     int(11) not null,
  user_id           int(11) not null,
  ctime             datetime null,
  
  approved          int(1) not null default 0,
  
  title             varchar(255) not null default '',
  message           text not null default '',
  
  status            varchar(50) not null default '',
  votes_for         int(11) not null default 0,
  votes_against     int(11) not null default 0,
  rating            int(11) not null default 0,
  
  starred_by_users  text not null default '',
  
  key(cloud_page_id,ctime),
  key(cloud_page_id,rating,ctime)
);

create table jin_cloud_comment
(
  id        int(11) not null primary key,
  signature char(8) not null default '',
  
  ctime     datetime null,
  cloud_id  int(11) not null,
  user_id   int(11) not null,
  
  message   text not null default '',
  
  key(cloud_id,ctime)
);

create table jin_cloud_starred
(
  cloud_id  int(11) not null default 0,
  user_id   int(11) not null default 0,
  
  key(cloud_id,user_id)
);

create table jin_reminder
(
  id              int(11) NOT NULL  primary key,
  
  type            varchar(100) NOT NULL default '',
  title           varchar(255) NOT NULL default '',
  comment         text NOT NULL,
  event_date      datetime default NULL,
  remind_date     datetime default NULL,
  recurring       tinyint(2) NOT NULL default '0',
  recur_until     datetime default NULL
);

create table jin_reminder_type
(
  title           varchar(100) NOT NULL default ''
);

create table jin_helpticket
(
  id                  int(11) not null primary key,
  
  ticket_code         char(10) not null default '',
  is_initial          int(1) not null default 0,

#gone in jin-3-36  
#  thread_id           int(11) not null default 0,
  user_id             int(11) not null default 0,
  
  subject             varchar(255) not null default '',
  message             text not null default '',
  
  ctime               datetime null,
  tstamp_activity     datetime null,
  
  status              int(1) not null default 1,
  
  category            varchar(255) not null default '',
  
  key(status,ctime),
  key(ticket_code),
  key(is_initial)
);

create table jin_helpticket_settings
(
  id                  int(11) not null primary key,
  submit_instr        text not null default ''
);

create table jin_helpticket_category
(
  id                  int(11) not null primary key,

  title               varchar(255) not null default '',
  pipe_email          varchar(50) not null default '',
  staff_ids           varchar(255) not null default '',
  staff_signature     text not null default '',
  subject_prefix      varchar(50) not null default '',
  membership_ids      varchar(255) not null default '',
  specusers_ids       varchar(255) not null default '',
  access_error        text not null default ''
);

create table jin_metaaff
(
  id            int(11) not null primary key,
  
  title         varchar(255) not null default '',
  
  aff_selected  varchar(255) not null default '',
  aff_group     varchar(255) not null default ''
);

create table jin_content_series
(
  id             int(11) not null primary key,
  
  url            varchar(255) not null default '',
  title          varchar(255) not null default '',
  template       longtext not null default '',
  start_time     datetime null,
  membership_id  int(11) not null,
  loop_enabled   int(1) not null default 0,
  delay_for_n    varchar(10) not null default '',
  delay_for_u    char(1) not null default 0,
  
  key(url)
);

create table jin_content_series_step
(
  id             int(11) not null primary key,
  series_id      int(11) not null default 0,
  
  display_for_n  varchar(10) not null default '',
  display_for_u  char(1) not null default 0,
  content        longtext not null default '',
    
  key(series_id)
);

create table jin_dbbackup
(
  id             int(11) not null primary key,
  
  enabled        int(1) not null default 0,
  period_u       char(1) not null default 0,
  ftp_serv       varchar(255) not null,
  ftp_user       varchar(255) not null,
  ftp_pass       varchar(255) not null,
  ftp_dir        varchar(255) not null,
  limit_backups  varchar(50) not null default ''
);

create table jin_lesson_series
(
  id                 int(11) not null primary key,
  
  title              varchar(50) not null default '',
  template           longtext not null default '',
  
  email_welcome      text not null default '',
  email_next_lesson  text not null default '',
  email_farewell     text not null default ''
);

create table jin_lesson
(
  id               int(11) not null primary key,
  
  series_id        int(11) not null,
  seq              int(3) not null,
  
  title            varchar(50) not null default '',
  
  display_for_l    int(11) not null default 0,
  display_for_u    varchar(10) not null default '',
  
  content          text not null default '',
  links            text not null default '',
  videos           varchar(255) not null default '',
  
  key(series_id,seq)
);

create table jin_video
(
  id          int(11) not null primary key,
  
  title       varchar(50) not null default '',
  
  player      varchar(30) not null default '',
  youtube_id  varchar(30) not null default '',
  url         varchar(255) not null default ''
);


create table jin_reflink
(
  id            int(11) not null primary key,

  user_id       int(11) not null,
  parent_id     int(11) not null default 0,
  
  introduction  text not null,
  url           varchar(255) not null default '',
  overridden    int(1) not null default 0,
  
  key(user_id, parent_id),
  key(parent_id)
);

create table jin_reflink_settings
(
  id                   int(11) not null primary key,
  
  limit_for_affiliate  int(11) not null default 0,
  limit_for_display    int(11) not null default 0,
  template             longtext not null default ''
);

create table jin_funnel_step
(
  id                   int(11) not null primary key,
  
  funnel_id            int(11) not null,
  
  title                varchar(255) not null default '',
  
#  edit_splitpage_id    int(11) not null default 0,
  
  pgate                int(11) not null default 0,

  backpay_override     int(1) not null default 0,
  backpay_pgates       varchar(50) not null default '',

  emaildlvs            varchar(255) not null default '',
  
  key(funnel_id)
);

create table jin_funnel_splitpage
(
  id                   int(11) not null primary key,

  step_id              int(11) not null,
  
  title                varchar(255) not null default '',
  weight               int(11) not null default 0,
  template             longtext not null default '',
  template_comp        longtext not null default '',

  notes                text not null default '',
  is_default           int(1) not null default 0,
  is_nowedit           int(1) not null default 0,

  key(step_id)
);

create table jin_funnel_condition
(
  id                   int(11) not null primary key,

  step_id              int(11) not null,
  set_type             int(1) not null default 0,
  ord                  int(3) not null default 0,
  
  cond_type            varchar(10) not null default '',
  cond_obj_id          int(11) not null default 0,
  
  next_step_id         int(11) not null default 0,

  key(step_id,set_type)
);

create table jin_funnel_visit
(
  funnel_id            int(11) not null,
  code                 char(16) not null default '',

  tstamp_start         datetime null,
  tstamp               datetime null,
  seq                  int(3) not null default 0,

  step_id              int(11) not null default 0,
  splitpage_id         int(11) not null default 0,

  action               varchar(15) not null default '',
  param_id             int(11) not null default 0,
  param_text           varchar(255) not null default '',

  user_id              int(11) not null default 0,
  order_id             int(11) not null default 0,
  
  user_ip              varchar(50) not null default '',
  user_cookie          varchar(50) not null default '',

  key(funnel_id,step_id),
  key(code),
  key(user_ip),
  key(user_cookie),
  key(user_id)
);

create table jin_funnel_splittest
(
  id                   int(11) not null primary key,
  
  funnel_id            int(11) not null,
  step_id              int(11) not null,

  title                varchar(255) not null default '',
  descr                text not null default '',

  datetime_from        datetime null,
  datetime_to          datetime null,

  dec_prec             int(1) not null default 0,

  testusers            varchar(255) not null default '',
  testips              varchar(255) not null default '',
  
  key(funnel_id),
  key(step_id)
);

create table jin_funnel_element
(
  id          int(11) not null primary key,

  title       varchar(255) not null default '',
  tagname     varchar(50) not null default '',
  data        text not null default '',
  
  key(tagname)
);

create table jin_abandone
(
  tstamp               datetime null,

  pack_id              int(11) not null default 0,
  user_id              int(11) not null default 0,

  primary key(pack_id,user_id)
);

create table jin_backlink
(
  id           int(11) not null primary key,
  
  title        varchar(40) not null default '',
  url          varchar(255) not null default '',
  descr        varchar(150) not null default '',
  image        varchar(255) not null default '',
  
  rating_self  int(11) not null default 0,
  rating       int(11) not null default 0,
  
  last_id      int(11) not null default 0,
  last_ip      varchar(50) not null default '',
  
  key(rating)
);

create table jin_insignia_group
(
  id     int(11) not null primary key,
  
  title  varchar(255) not null default ''
);

create table jin_insignia_category
(
  id         int(11) not null primary key,
  
  group_id   int(11) not null default 0,

  tstamp     datetime null,
  
  title      varchar(255) not null default '',
  color      varchar(30) not null default '',
  
  fulltitle  varchar(255) not null default '',
  
  key(group_id)
);

create table jin_survey
(
  id                   int(11) not null primary key,

  title                varchar(255) not null default '',

  user_acl             varchar(255) not null default '',

  intro_html           text not null default '',

  return_url           varchar(255) not null default '',
  return_html          text not null default '',
  
  password             varchar(50) not null default '',
  use_captcha          int(1) not null default 0,
  archive_after        int(4) not null default 0
);

create table jin_survey_question
(
  id                   int(11) not null primary key,

  survey_id            int(11) not null default 0,

  title                varchar(255) not null default '',
  seq                  int(3) not null default 0,
  pagebreak            int(1) not null default 0,
  required             int(1) not null default 0,
  
  selector_data        text not null default '',
  selector_type        varchar(30) not null default '',

  text_enabled         int(1) not null default 0,
  text_type            varchar(30) not null default '',
  text_caption         varchar(255) not null default '',
  text_is_big          int(1) not null default 0,  

  intro_html           int(11) not null default 0,

  key(survey_id)
);

create table jin_survey_data
(
  id                   int(11) not null primary key,

  tstamp               datetime null,

  survey_id            int(11) not null default 0,
  user_id              int(11) not null default 0,

  page_completed       int(2) not null default 0,
  
  archived             int(1) not null default 0,

  key(user_id),
  key(survey_id),
  key(archived)
);

create table jin_survey_data_small
(
  data_id              int(11) not null default 0,
  question_id          int(11) not null default 0,

  answer               varchar(255) not null default '',
  
  seq                  int(11) not null default 0,
  
  key(data_id,question_id)
);

create table jin_survey_data_big
(
  data_id              int(11) not null default 0,
  question_id          int(11) not null default 0,

  answer               text not null default '',
  
  seq                  int(11) not null default 0,
  
  key(data_id,question_id)
);

create table jin_emaildlv
(
  id                  int(11) not null primary key,
  
  anchor_code         varchar(70) not null default '',
  
  title               varchar(255) not null default '',

  from_name           varchar(255) not null default '',
  from_email          varchar(255) not null default '',

  subject             varchar(255) not null default '',
  message             text not null default '',
  
  delay               int(3) not null default 0,
  disabled            int(1) not null default 0,
  
  key(anchor_code)
);

create table jin_emaildlv_delayed
(
  id                  int(11) not null primary key auto_increment,
  tstamp_send         datetime null,  
  serialized          blob not null default '',
  key(tstamp_send)
);

create table jin_api_post
(
  id                  int(11) not null primary key,
  
  type                varchar(20) not null default '',

  title               varchar(255) not null default '',

  url                 varchar(255) not null default '',
  params              text not null default '',

  method              varchar(4) not null default '',

  events              varchar(50) not null default '',

  mod_plugin          varchar(20) not null default '',
  
  key(type)
);

create table jin_user_email_log
(
  id                  int(11) not null primary key,

  user_id             int(11) not null default 0,

  tstamp              datetime null,
  method              varchar(30) not null default '',

  from_string         varchar(255) not null default '',
  
  subject             varchar(255) not null default '',
  message             text not null default '',
  attachments         text not null default '',

  attr                varchar(255) not null default '',
  
  key(user_id)
);


create table jin_trackable_url
(
  id           int(11) not null primary key,
  label        varchar(255) not null default '',

  title        varchar(255) not null default '',
  admin_notes  text not null default '',

  alias        varchar(255) not null default '',
  url          varchar(255) not null default '',
  page         longtext not null default '',

  clicks       int(11) not null default 0,
  orders       int(11) not null default 0
);

create table jin_trackable_url_order
(
  trackurl_id  int(11) not null default 0,
  order_id     int(11) not null default 0,
  primary key(trackurl_id,order_id)
);

create table jin_ezine_points
(
  id           int(11) not null primary key,

  title        varchar(255) not null default '',
  admin_notes  text not null default '',

  points       int(11) not null,

  url          varchar(255) not null default '',
  page         longtext not null default '',
  errmsg       text not null default '',

  clicks       int(11) not null default 0
);

create table jin_ezine_points_cashed
(
  ezp_id       int(11) not null default 0,
  user_id      int(11) not null default 0,
  primary key(ezp_id,user_id)
);

create table jin_ccs
(
  id           int(11) not null primary key auto_increment,
  user_id      int(11) not null default 0,
  ts           datetime null,
  d            tinyblob not null,
  e            int(1) not null default 0,
  key(user_id),
  key(e)
);

create table jin_tracking_link
(
  id           int(11) not null primary key,

  alias        varchar(70) not null default '',
  url          varchar(255) not null default '',

  admin_notes  text not null default '',

  clicks       int(11) not null default 0,
  uvisits      int(11) not null default 0
);

create table jin_paycomm_period
(
  id           int(11) not null primary key,

  date_start        datetime null,
  date_end          datetime null,
  next_period_days  int(3) not null default 0
);

create table jin_longtexts
(
  id     int(11) not null primary key auto_increment,
  data   longtext not null default ''
);

create table jin_texts
(
  id     int(11) not null primary key auto_increment,
  data   text not null default ''
);

create table jin_user_custom_field
(
  id int(11) not null primary key
);

create table jin_datalog
(
  id          int(11) not null primary key auto_increment,

  tstamp      datetime null,
  user_id     int(11) not null default 0,

  sqltable    varchar(30) not null default '',
  record_id   int(11) not null default 0,
  sqlfield    varchar(30) not null default '',

  value1      varchar(255) not null default '',
  value2      varchar(255) not null default '',
  
  comment     varchar(255) not null default '',
  
  key(sqltable,sqlfield,record_id)
);

create table jin_sys_alert
(
  tstamp      datetime null,
  expires     datetime null,
  code        varchar(50) not null default '',
  value       varchar(50) not null default '',
  unique key(code)
);

create table jin_text_revision
(
  id          int(11) not null primary key auto_increment,
  
  obj_type    varchar(15) not null default '',
  obj_id      int(11) not null default 0,
  
  tstamp      datetime null,
  user_id     int(11) not null default 0,
  comment     varchar(255) not null default '',
 
  data        longtext not null default '',

  key(obj_type,obj_id)
);

create table jin_skip_branch_condition
(
  id                   int(11) not null primary key,

  scope_type           varchar(15) not null default '',
  scope_id             int(11) not null default 0,

  ord                  int(3) not null default 0,
  
  cond_type            varchar(10) not null default '',
  cond_obj_id          int(11) not null default 0,
  
  action               varchar(10) not null default '',

  key(scope_type,scope_id)
);

create table jin_satellite_installation
(
  id                   int(11) not null primary key,

  url                  varchar(50) not null default '',
  admin_email          varchar(255) not null default '',
  admin_passwd         varchar(255) not null default ''
);

create table jin_external_ipn
(
  id                  int(11) not null primary key auto_increment,

  pgate_id            int(11) not null default 0,
  pgate_title         varchar(50) not null default '',

  ip                  varchar(32) not null default '',
  tstamp              datetime null,
  verified            int(1) not null default 0,
  fingerprint         varchar(32) not null default '',

  data                text not null default '',

  sale_id             int(11) not null default 0,

  key(fingerprint),
  key(sale_id)
);

create table jin_api_gate
(
  id                  int(11) not null primary key,

  title               varchar(255) not null default '',
  apikey              varchar(255) not null default '',
  
  apicalls            varchar(255) not null default '',
  specusers           int(11) not null default 0
);

create table jin_payplan
(
  id                      int(11) not null primary key,

  prod_id                 int(11) not null default 0,
  title                   varchar(255) not null default '',

  is_flat                 int(1) not null default 0,

  amount                  varchar(15) not null default '',

  period_l                varchar(10) not null default '',
  period_u                char(1) not null default '',
  numinst                 varchar(10) not null default '',
  
  trial_l                 varchar(10) not null default '',
  trial_u                 char(1) not null default '',
  trial_amount            varchar(15) not null default '',

  shipping                int(1) not null default 0,

  pgates                    varchar(255) not null default '',

  key(prod_id)
);

create table jin_smtp_server
(
  id           int(11) not null primary key,
  title        varchar(150) not null default '',
  
  smtp_server  varchar(100) not null default '',
  port INT(5)  NOT NULL DEFAULT '25',
  auth_user    varchar(50) not null default '',
  auth_pass    varchar(50) not null default '',
  
  active       int(1) not null default 0,
  tls TINYINT(1) NOT NULL DEFAULT 0,
  
  key(active)
);

CREATE TABLE `jin_ext_script_action`
(
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `ext_script_id` int(11) DEFAULT NULL,
  `case` tinyint(1) DEFAULT NULL,
  `action` tinyint(1) DEFAULT NULL,
  `product_id` int(11) DEFAULT NULL,
  `package_id` int(11) DEFAULT NULL,
  `donr` int(3) DEFAULT NULL,
  `dbs` int(3) DEFAULT NULL,
  `dbt` int(3) DEFAULT NULL,
  `dbs_email` text,
  `dbt_email` text,
  PRIMARY KEY (`id`)
);

CREATE TABLE `jin_ext_script_action_log`
(
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `action_id` int(11) DEFAULT NULL,
  `dlv_id` int(11) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `dt_onr` date DEFAULT NULL,
  `is_onr` tinyint(1) DEFAULT NULL,
  `dt_suspend` date DEFAULT NULL,
  `is_suspended` tinyint(1) DEFAULT '0',
  `dt_terminate` date DEFAULT NULL,
  `is_terminated` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IX_UNIQUE` (`action_id`,`dlv_id`,`user_id`)
);

CREATE TABLE IF NOT EXISTS `jin_specusers_filters` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `value` varchar(255) DEFAULT NULL,
  `parent` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `IX_UNIQUE` (`name`,`parent`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
