package IIaefee7d7a33304f962f66cd7facb90a8::mod_InvisionPB; use strict; use base 'JinPluginBaseExtScript'; use DBI; use Digest::MD5 qw(md5_hex); sub init { my $this = shift()->SUPER::init(@_); return $this->msg('error.missing_config') if grep { ! $this->{$_} } qw/dbhost dbname dbuser/; $this->{dbh} = DBI->connect("DBI:mysql:$this->{dbname}:$this->{dbhost}", $this->{dbuser}, $this->{dbpass}) or return $this->msg('error.connect_db', $DBI::errstr); my $sth = $this->sql('show tables like ?', "$this->{tblprefix}members"); return $this->msg('error.tables_not_found', $this->{tblprefix}) unless $sth->rows > 0; return; } sub addUser { my $this = shift; my $user = shift; my $script_uid = $this->_get_script_uid($user); if ($script_uid) { $this->updateUser($user); } else { my $memberName = $this->getUsernameForUser($user); my $salt = _generate_salt(5); my $time = time; my $cvRegOptions = { converge_email => "$user->{email}", converge_joined => $time, converge_pass_hash => md5_hex(md5_hex($salt) . md5_hex($user->{passwd})), converge_pass_salt => $salt, }; my @f = keys %$cvRegOptions; $this->sql("INSERT INTO $this->{tblprefix}members_converge SET " . join(',', map { "$_=?" } @f), map { $cvRegOptions->{$_} } @f) or return; my $sth = $this->sql("SELECT converge_id FROM $this->{tblprefix}members_converge WHERE converge_email=? and converge_pass_salt=?", $user->{email}, $salt) or return; return $this->failure('error.converge_not_found', "[$memberName] [$salt]") unless $sth->rows > 0; my $convergeId = $sth->fetchrow_array; $sth = $this->sql("SELECT g_id FROM $this->{tblprefix}groups WHERE g_title='Members'") or return; return $this->failure('error.group_not_found', "Members") unless $sth->rows > 0; my $groupId = $sth->fetchrow_array; my $regOptions = { id => $convergeId, name => $memberName, mgroup => $groupId, email => "$user->{email}", joined => $time, ip_address => "$ENV{REMOTE_ADDR}", members_display_name => "$user->{name}", members_l_username => lc($memberName), members_l_display_name => lc($user->{name}), member_login_key => md5_hex(_generate_salt(60)), }; @f = keys %$regOptions; $this->sql("INSERT INTO $this->{tblprefix}members SET " . join(',', map { "$_=?" } @f), map { $regOptions->{$_} } @f) or return; $script_uid = $convergeId; $this->fixScriptUID($user, $script_uid); } return $script_uid; } sub updateUser { my $this = shift; my $user = shift; if (my $script_uid = $this->_get_script_uid($user)) { my $memberName = $this->getUsernameForUser($user); my $salt = _generate_salt(5); $this->sql("UPDATE $this->{tblprefix}members_converge SET converge_email=?, converge_pass_hash=?, converge_pass_salt=? WHERE converge_id=?", "$user->{email}", md5_hex(md5_hex($salt).md5_hex($user->{passwd})), $salt, $script_uid, ) or return; $this->sql("UPDATE $this->{tblprefix}members SET name=?, email=?, members_display_name=?, members_l_username=?, members_l_display_name=? WHERE id=?", $memberName, "$user->{email}", "$user->{name}", lc($memberName), lc($user->{name}), $script_uid, ) or return; $this->fixScriptUID($user, $script_uid); } else { $this->addUser($user); } return; } sub deleteUser { my $this = shift; my $user = shift; my $script_uid = $this->_get_script_uid($user) or return; $this->sql("DELETE FROM $this->{tblprefix}member_extra WHERE id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}members WHERE id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}members_converge WHERE converge_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}contacts WHERE member_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}forum_tracker WHERE member_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}moderators WHERE member_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}profile_friends WHERE friends_member_id=? OR friends_friend_id=?", $script_uid, $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}sessions WHERE member_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}tracker WHERE member_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}validating WHERE member_id=?", $script_uid) or return; $this->sql("DELETE FROM $this->{tblprefix}voters WHERE member_id=?", $script_uid) or return; $this->sql("UPDATE $this->{tblprefix}posts SET author_id=0 WHERE author_id=?", $script_uid) or return; $this->sql("UPDATE $this->{tblprefix}topics SET starter_id=0 WHERE starter_id=?", $script_uid) or return; $this->fixScriptUID($user, undef); return; } sub suspendUser { my $this = shift; my $user = shift; $this->deleteUser($user); return; } sub getUsernameForUser { my $this = shift; my $user = shift; $user->{email}; } sub _get_script_uid { my $this = shift; my $user = shift; my $script_uid = $this->getScriptUID($user); if ($script_uid) { my $sth = $this->sql("SELECT id FROM $this->{tblprefix}members WHERE id=?", $script_uid) or return; if (! $sth->rows > 0) { $script_uid = undef; $this->fixScriptUID($user, undef); } } for my $un ($this->getUsernameForUser($user), 'user'.$user->id) { my $sth = $this->sql("SELECT id FROM $this->{tblprefix}members WHERE name=?", $un) or return; if ($sth->rows > 0) { $script_uid = $sth->fetchrow_array; last; } } $script_uid; } sub _generate_salt { my $len = shift; my	$salt = ''; for (my $i = 0; $i < $len; $i++) { my $num = 33 + rand(126 - 33); $num = 93 if $num == 92; $salt .= chr($num); } return $salt; } 1;